/*
 *  This file is part of Dune Legacy.
 *
 *  Dune Legacy is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Dune Legacy is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Dune Legacy.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GAMEINILOADER_H
#define GAMEINILOADER_H

#include <FileClasses/INIFile.h>

#include <string>
#include <misc/memory.h>


// forward declarations
class GameClass;
class PlayerClass;

class GameINILoader {
public:
	GameINILoader(GameClass* pGameClass, std::string mapname);
	~GameINILoader();

private:
    void load();
    void loadMap();
    void loadPlayers();
    void loadChoam();
    void loadUnits();
    void loadStructures();
    void loadReinforcements();
    void loadView();

    PlayerClass* getOrCreatePlayer(int house);

    GameClass* pGameClass;
    std::string mapname;
    std::shared_ptr<INIFile> inifile;
};

#endif //GAMEINILOADER_H
